// File: uRunExplorer.pas
// Date: 08.11.2011
// Descroption: Explorer 

unit uRunExplorer;

interface

uses
  TlHelp32, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI;

type
  TFormRunExplorer = class(TForm)
    btRunExplorer: TButton;
    btKillExplorer: TButton;
    procedure btRunExplorerClick(Sender: TObject);
    procedure btKillExplorerClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormRunExplorer: TFormRunExplorer;

implementation

{$R *.dfm}

const TerminateName = 'explorer.exe';

function FindExplorer(): boolean;
var
  FSnapshotHandle, ProcessHandle: THandle;
  FProcessEntry32: TProcessEntry32;
  S : String;
begin

  Result := True;
  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
  Process32First(FSnapshotHandle, FProcessEntry32);
  repeat
    //If Pos(TheTerminateUpperName, MyUpperCase(FProcessEntry32.szExeFile)) > 0 then
    //S := UpperCase(FProcessEntry32.szExeFile);
    If (FProcessEntry32.szExeFile = TerminateName) then
    Begin
      //ShowMessage(' explorer.exe!');
      ProcessHandle := OpenProcess(PROCESS_TERMINATE, BOOL(0), FProcessEntry32.th32ProcessID);
      if ProcessHandle <> 0 then
        begin
          Result := Result and  TerminateProcess(ProcessHandle, 0);
          if (not Result) then
            MessageBox(0, Pchar(SysErrorMessage(GetLastError)), 'Error1', 0);
          CloseHandle(ProcessHandle);

        end
        else
          //MessageBox(0, Pchar(SysErrorMessage(GetLastError)), 'Error2', 0);
  End;
  Until not Process32Next(FSnapshotHandle, FProcessEntry32);

  CloseHandle(FSnapshotHandle);

end;


procedure TFormRunExplorer.btKillExplorerClick(Sender: TObject);
var
  id: Integer;
  hPr: cardinal;
begin
  //  Explorer
  //id := StrToInt(Edit1.Text);
  //hPr := OpenProcess(PROCESS_TERMINATE, False, id);
  //TerminateProcess(hPr, 1);
  FindExplorer();
end;




procedure TFormRunExplorer.btRunExplorerClick(Sender: TObject);
var
  FileName : String;
  SUInfo : TStartUpInfo;
  ProcInfo : TProcessInformation;
begin


  ZeroMemory(@SUInfo, SizeOf(TStartUpInfo));
  with SUInfo do
  begin
   cb := SizeOf(TStartUpInfo);
   dwFlags := STARTF_USESHOWWINDOW;
   wShowWindow := SW_SHOWNORMAL;
  end;

  FileName := 'Explorer.exe';
  CreateProcess(PChar('C:\\Windows\\' + FileName), nil, nil, nil, False, 0, nil, nil, SUInfo, ProcInfo);

end;



end.

  //ShellExecute(Handle, 'open', 'explorer.exe', 'C:\Windows\system32', '', SW_SHOW);
  //WinExec(PANsiChar('TASKKILL /F /IM explorer.exe'), SW_HIDE);
  //sleep(5000);
  //ShellExecute(Handle,'open','C:\WINDOWS\Explorer.EXE',nil,nil,SW_ShowNormal);


